﻿<?php
/*
shahrPayment - class for shahr bank internet payment gateway
version 1.0
Copyright (c) 2013 Citydi Co.

The shahrPayment class home is:
http://www.citydi.com

If you have any questions or comments, please email:
contact@citydi.com
*/


class shahrPayment{
	
	public $mid = null;
	public $user = null;
	public $pass = null;
	public $userAuthSession = false;
	public $errorLevel = 0;
	public $error = "";
	public $transactionType = array("PURCHASE"=>"خرید","BILL_PAYMENT"=>"پرداخت قبض");
	public $transactionState = array("SUCCESS"=>"موفق","NOT_VERIFIED"=>"تایید نشده","FAILED"=>"ناموفق");
	
	public function __construct( $user = "user" , $pass = "pass" ){
		$this->user = $user;
		$this->pass = $pass;
	}
	
	public function paymentRequest( $amount , $invoiceId , $redirectUrl , $mid ){
			$this->mid = $mid ;
			
			$form = "<form name='paymentForm' action='https://epay.tehran.ir/cardmanager/controller' method='post'>";
			$form .= "<input type='hidden' name='RedirectURL' value='$redirectUrl' />";
			$form .= "<input type='hidden' name='MID' value='$mid' />";
			$form .= "<input type='hidden' name='ResNum' value='$invoiceId' />";
			$form .= "<input type='hidden' name='Amount' value='$amount' />";
			$form .= "</form>";
			$form .= "<script language='javascript'>document.paymentForm.submit()</script>";
			return $form;
			
	}
	
	public function billPaymentRequest( $redirectUrl , $paymentId , $billId ){
			
			$form = "<form name='billPaymentForm' action='https://epay.tehran.ir/cardmanager/billController' method='post'>";
			$form .= "<input type='hidden' name='RedirectURL' value='$redirectUrl' />";
			$form .= "<input type='hidden' name='paymentId' value='$paymentId' />";
			$form .= "<input type='hidden' name='billId' value='$billId' />";
			$form .= "</form>";
			$form .= "<script language='javascript'>document.billPaymentForm.submit()</script>";
			echo $form;
			
	}
	
	public function verifyPayment($refNumber){
		
		try {
			$client = new SoapClient("https://epay.tehran.ir/merchantwebservice/jax/merchantAuth?wsdl",array("exceptions" => 1));
			$result = $client->login(array('loginRequest' =>array('username'=>$this->user,'password'=>$this->pass)));	
			
			if(isset($result->return)){
				$userAuthSession = $result->return;
				$result = $client->verifyTransaction(array(
						'context'=>array(
							'data'=>array(
								'entry'=>array(
									'key'=>'SESSION_ID',
									'value'=>$userAuthSession
								)
							)
						),'verifyRequest' =>array('refNumList'=>$refNumber)));
	
				if(isset($result->return->verifyResponseResults->verificationError)){
					echo $this->errorHandel("103",$result->return->verifyResponseResults->verificationError);
					return false;
				} else {
					return true;	
				}
				
			} else {
				echo $this->errorHandel("101","Authentication failed");
				return false;
			}
			
		} catch (SoapFault $fault) {
			echo $this->errorHandel("102","SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})");
		}
		
	}
	
	public function cancelPayment( $refNumber , $amount = 0 , $invoiceId ){
		try {
			$client = new SoapClient("https://epay.tehran.ir/merchantwebservice/jax/merchantAuth?wsdl",array("exceptions" => 1));
			$result = $client->login(array('loginRequest' =>array('username'=>$this->user,'password'=>$this->pass)));	

			if(isset($result->return)){
				$userAuthSession = $result->return;
				$result = $client->reverseTransaction(array(
						'context'=>array(
							'data'=>array(
								'entry'=>array(
									'key'=>'SESSION_ID',
									'value'=>$userAuthSession
								)
							)
						),'reverseRequest' =>array(
								'mainTransactionRefNum'=>$refNumber,
								'reverseTransactionResNum'=> $invoiceId,
								'amount'=>$amount
							)));
			} else {
				echo $this->errorHandel("201","Authentication failed");
				return false;
			}
					
			if(isset($result->return->refNum)){
				return true;
			} else {
				echo "Failed Transaction";
				return false;	
			}
			
		} catch (SoapFault $fault) {
			echo $this->errorHandel("202","SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})");
		}
	}
	
	
	public function getTransactionReport( $refNumber ){
		try {
			$client = new SoapClient("https://epay.tehran.ir/merchantwebservice/jax/merchantAuth?wsdl",array("exceptions" => 1));
			$result = $client->login(array('loginRequest' =>array('username'=>$this->user,'password'=>$this->pass)));
			
			
			if(isset($result->return)){
				$userAuthSession = $result->return;
				$result = $client->reportTransaction(array(
						'context'=>array(
							'data'=>array(
								'entry'=>array(
									'key'=>'SESSION_ID',
									'value'=>$userAuthSession
								)
							)
						),'reportRequest' =>array(
							'length'  => '1',
							'offset'  => '0',
							'onlyReversed'=> false,
							'refNum'  => $refNumber
						)));
			} else {
				echo $this->errorHandel("301","Authentication failed");
				return false;
			}
			
			
			if($result->return->totalRecord!=0){
				$resultArray = array();
				$resultArray['amount'] = $result->return->reportResponseResults->amount;
				$resultArray['customerRefNum'] = $result->return->reportResponseResults->customerRefNum;
				$resultArray['refNum'] = $result->return->reportResponseResults->refNum;
				$resultArray['transactionStateCode'] = $result->return->reportResponseResults->transactionState;
				$resultArray['transactionState'] = $this->transactionState[$result->return->reportResponseResults->transactionState];
				$resultArray['transactionTypeCode'] = $result->return->reportResponseResults->transactionType;
				$resultArray['transactionType'] = $this->transactionType[$result->return->reportResponseResults->transactionType];
				return $resultArray;
			} else {
				echo "نتیجه ای یافت نشد";	
			}
			
		} catch (SoapFault $fault) {
			echo $this->errorHandel("302","SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})");
		}
			
			
	}
	
	public function getTransactionReportDetail( $refNumber ){
		try {
			$client = new SoapClient("https://epay.tehran.ir/merchantwebservice/jax/merchantAuth?wsdl",array("exceptions" => 1));
			$result = $client->login(array('loginRequest' =>array('username'=>$this->user,'password'=>$this->pass)));
			
			
			if(isset($result->return)){
				$userAuthSession = $result->return;
				$result = $client->reportTransaction(array(
						'context'=>array(
							'data'=>array(
								'entry'=>array(
									'key'=>'SESSION_ID',
									'value'=>$userAuthSession
								)
							)
						),'detailReportRequest' =>array(
							'length'  => '1',
							'offset'  => '0',
							'onlyReversed'=> false,
							'refNum'  => $refNumber
						)));
			} else {
				echo $this->errorHandel("401","Authentication failed");
				return false;
			}
			
			
			if($result->return->totalRecord!=0){
				$resultArray = array();
				$resultArray['amount'] = $result->return->reportResponseResults->amount;
				$resultArray['resNum'] = $result->return->reportResponseResults->resNum;
				$resultArray['refNum'] = $result->return->reportResponseResults->refNum;
				$resultArray['time'] = $result->return->reportResponseResults->time;
				return $resultArray;
			} else {
				echo "نتیجه ای یافت نشد";	
			}
			
		} catch (SoapFault $fault) {
			echo $this->errorHandel("402","SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})");
		}
			
			
	}
	
	
	public function errorHandel($code,$message){
		if($this->errorLevel==0){
			return 	"خطا در تراکنش";
		} else {
			return $code."! ".$message;
		}
	}
	
	
	
}